//---------------------------------------------------------------------------

#ifndef MainFormUnitH
#define MainFormUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnCtrls.hpp>
#include <ActnList.hpp>
#include <ActnMan.hpp>
#include <ActnMenus.hpp>
#include <ComCtrls.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>
#include <Chart.hpp>
#include <DbChart.hpp>
#include <ExtCtrls.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>
#include <Series.hpp>
#include <Menus.hpp>
#include <CheckLst.hpp>
#include <Dialogs.hpp>
#include <jpeg.hpp>
#include <DBChart.hpp>
#include "TeeTools.hpp"
#include "TeeEdit.hpp"
#include <TeeLisB.hpp>
#include <ImgList.hpp>
#include <ArrowCha.hpp>
#include <GanttCh.hpp>
#include "TeeSeriesTextEd.hpp"
#include "TeeURL.hpp"
//#include "SeriesDisplay.h"
//#include "CollectionThread.h"
#include <Data.DB.hpp>
#include <System.Actions.hpp>
#include <System.ImageList.hpp>
#include <VclTee.TeeGDIPlus.hpp>
#include <Vcl.Mask.hpp>

//---------------------------------------------------------------------------
class BatchHistoryExplorer;
class SeriesDisplay;
class SettingsPersistence;

class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TStatusBar *StatusBar1;
    TDBChart *DBChart;
    TLineSeries *Series1;
    TLineSeries *Series2;
    TLineSeries *Series3;
    TLineSeries *Series4;
    TLineSeries *Series5;
    TLineSeries *Series6;
    TLineSeries *Series7;
    TLineSeries *Series8;
    TLineSeries *Series9;
    TLineSeries *Series0;
    TTreeView *BatchHistoryTreeView;
    TSplitter *BHSplitter;
    TPopupMenu *BHPopupMenu;
    TMenuItem *DeleteBHPopupMenuItem;
    TLineSeries *Series10;
    TLineSeries *Series11;
    TLineSeries *Series12;
    TLineSeries *Series13;
    TLineSeries *Series14;
    TLineSeries *Series15;
    TLineSeries *Series16;
    TLineSeries *Series17;
    TLineSeries *Series18;
    TLineSeries *Series19;
    TActionList *MainActionList;
    TAction *FileExportAction;
    TFilePrintSetup *FilePrintSetup;
    TAction *FilePrintAction;
    TFileExit *FileExit;
    THelpContents *HelpContents;
    THelpTopicSearch *HelpTopicSearch;
    TAction *HelpAboutAction;
    TAction *ViewBatchHistoryExplorerAction;
    TAction *ViewHorizontalGridLinesAction;
    TAction *ViewVerticalGridLinesAction;
    TMainMenu *MainMenu;
    TMenuItem *File1;
    TToolBar *ToolBar;
    TMenuItem *ExportMenuItem;
    TMenuItem *N1;
    TMenuItem *PrintSetupMenuItem;
    TMenuItem *PrintMenuItem;
    TMenuItem *N2;
    TMenuItem *ExitMenuItem;
    TMenuItem *ViewMenuItem;
    TMenuItem *BatchHistoryExplorerMenuItem;
    TMenuItem *HelpContentsMenuItem;
    TMenuItem *Contents1;
    TMenuItem *TopicSearch1;
    TMenuItem *About1;
    TAction *ViewPlotSelectorAction;
    TMenuItem *GridLinesMenuItem;
    TMenuItem *HorizontalGridLinesMenuItem;
    TMenuItem *VerticalGridLinesMenuItem;
    TPrintDialog *PrintDialog;
    TToolButton *ToolButton1;
    TToolButton *ToolButton2;
    TLineSeries *Series20;
    TLineSeries *Series21;
    TLineSeries *Series22;
    TLineSeries *Series23;
    TLineSeries *Series24;
    TLineSeries *Series25;
    TLineSeries *Series26;
    TLineSeries *Series27;
    TLineSeries *Series28;
    TLineSeries *Series29;
    TLineSeries *Series30;
    TLineSeries *Series31;
    TLineSeries *Series32;
    TLineSeries *Series33;
    TLineSeries *Series34;
    TLineSeries *Series35;
    TLineSeries *Series36;
    TLineSeries *Series37;
    TLineSeries *Series38;
    TLineSeries *Series39;
    TLineSeries *Series40;
    TLineSeries *Series41;
    TAction *ViewTemperatureAction;
    TAction *ViewGasAction;
    TAction *ViewLoadStationAction;
    TMenuItem *PlotMenuItem;
    TMenuItem *TemperatureMenuItem;
    TMenuItem *GasMenuItem;
    TMenuItem *Load;
    TChartPreviewer *ChartPreviewer;
    TAction *FilePrintPreviewAction;
    TMenuItem *PrintPreviewMenuItem;
    TChartListBox *TempChartListBox;
    TSplitter *Splitter1;
    TMenuItem *PlotSelection1;
    TImageList *ToolBarImageList;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TToolButton *ToolButton6;
    TToolButton *ToolButton7;
    TToolButton *ToolButton8;
    TToolButton *ToolButton9;
    TToolButton *ToolButton10;
    TToolButton *ToolButton11;
    TGanttSeries *Series42;
    TSeriesTextSource *SeriesTextSource1;
    TGanttSeries *Series45;
    TGanttSeries *Series46;
    TGanttSeries *Series47;
    TGanttSeries *Series48;
    TGanttSeries *Series49;
    TGanttSeries *Series50;
    TGanttSeries *Series51;
    TGanttSeries *Series52;
    TAction *ViewChartTube1;
    TAction *ViewChartTube2;
    TAction *ViewChartTube3;
    TAction *ViewChartTube4;
    TMenuItem *ChartRealtime1;
    TMenuItem *ViewChartTube11;
    TMenuItem *ViewChartTube21;
    TMenuItem *ViewChartTube31;
    TMenuItem *ViewChartTube41;
    TTimer *RealTimer;
    TToolButton *ToolButton12;
    TPointSeries *Series43;
    TPointSeries *Series44;
    TPointSeries *Series53;
    TPointSeries *Series54;
    TPointSeries *Series55;
    TAreaSeries *Series56;
    TAreaSeries *Series57;
    TAreaSeries *Series58;
    TAreaSeries *Series59;
    TAreaSeries *Series60;
    TAreaSeries *Series61;
    TAreaSeries *Series62;
    TAreaSeries *Series63;
    TPointSeries *Series64;
    TAction *ToolsECConfigAction;
    TAction *ToolsDBMaintAction;
    TAction *ViewZoomInAction;
    TAction *ViewZoomOutAction;
    TAction *ViewHalveTimeAction;
    TAction *ViewDoubleTimeAction;
    TAction *ViewXSpanAction;
    TAction *ViewEventsStatesAction;
    TAction *ViewScrollingAction;
    TAction *ProcessNewPeriodAction;
    TAction *ProcessNewTestAction;
    TAction *ProcessEditPeriodTestAction;
    TAction *ProcessCollectDataAction;
    TAction *ProcessAddToOverlayAction;
    TToolButton *ToolButton13;
    TMenuItem *ProcessMenuItem;
    TMenuItem *ToolsMenuItem;
    TMenuItem *ViewXSpan1;
    TMenuItem *HalveTimeAxis1;
    TMenuItem *DoubleTimeAxis1;
    TMenuItem *ZoomIn1;
    TMenuItem *ZoomOut1;
    TMenuItem *Scrolling1;
    TMenuItem *ShowEventsandStates1;
    TMenuItem *NewDataPeriod1;
    TMenuItem *NewControlTest1;
    TMenuItem *EditPeriodorTestDefinition1;
    TMenuItem *CollectProcessData1;
    TMenuItem *AddToOverlay1;
    TMenuItem *ToolsDBMaintAction1;
    TMenuItem *ChangeECRegistry1;
    TMenuItem *NewPeriodBHPopupMenuItem;
    TMenuItem *RenameBHPopupMenuItem;
    TMenuItem *Edit1;
    TMenuItem *CollectProcessData2;
    TMenuItem *NewTestDefinition1;
    TToolButton *ToolButton14;
    TToolButton *ToolButton15;
    TToolButton *ToolButton16;
    TToolButton *ToolButton17;
    TToolButton *ToolButton18;
    TToolButton *ToolButton19;
    TToolButton *ToolButton20;
    TToolButton *ToolButtonSpacerProcessEdit;
    TToolButton *ToolButton22;
    TToolButton *ToolButton23;
    TToolButton *ToolButton24;
    TToolButton *ToolButtonSpacerProcessData;
    TToolButton *ToolButton26;
    TToolButton *ToolButton27;
    TToolButton *ToolButton28;
    TToolButton *ToolButton29;
    TToolButton *ToolButton30;
    TToolButton *ToolButton31;
    TToolButton *ToolButton32;
    TToolButton *ToolButton33;
    TAction *ViewHalveYAction;
    TAction *ViewDoubleYAction;
    TAction *ViewResetScalingAction;
    TToolButton *ToolButton34;
    TToolButton *ToolButton35;
    TToolButton *ToolButton36;
    TLineSeries *Series65;
    TLineSeries *Series66;
    TLineSeries *Series67;
    TLineSeries *Series68;
    TLineSeries *Series69;
    TLineSeries *Series70;
    TLineSeries *Series71;
    TLineSeries *Series72;
    TLineSeries *Series73;
    TLineSeries *Series74;
    TLineSeries *Series75;
    TLineSeries *Series76;
    TAction *ProcessExportDefnAction;
    TAction *ProcessExportDataAction;
    TMenuItem *ExportDefn;
    TMenuItem *ExportDataAction1;
    TEdit *ProgressEdit;
    TPointSeries *Series77;
    TPointSeries *Series78;
    TPointSeries *Series79;
    TToolBar *DatabaseToolBar;
    TLabel *RecipeLabel;
    TLabel *TubeTypeLabel;
    TComboBox *HistoryTubeFilterComboBox;
    TComboBox *HistoryRecipeFilterComboBox;
    TComboBox *DBSelectComboBox;
    TLabel *Label1;
    TProgressBar *ProgressBar;
    TUpDown *TempAxisUpDown;
    TUpDown *GasAxisUpDown;
    TUpDown *BoatAxisUpDown;
    TGanttSeries *SeriesGanttDisplay;
    TDateTimePicker *HistoryDateTimePicker;
    TLabel *SinceLabel;
    TAction *ProcessDeleteAction;
    TAction *ProcessDeleteSelectedItem;
    TMenuItem *DeleteSelectedItem;
    TMenuItem *DeleteItem1;
    TMenuItem *DeleteSelectedDataItem1;
    TMenuItem *AddToOverlay2;
    TAction *ProcessOverlayChangeValid;
    TMenuItem *ChangeSelectedOverlayValid1;
    TMenuItem *ChangeSelectedOverlayValid2;
    TToolButton *ToolButton37;
    TToolButton *ToolButton38;
    TToolButton *ToolButton39;
    TToolButton *ToolButton40;
    TToolButton *ToolButton41;
    TAction *ViewRefreshChart;
    TMenuItem *Refresh1;
    TAction *ViewRefreshTree;
    TToolButton *ToolButton42;
    TMenuItem *RefreshTree1;
    TToolButton *ToolButton43;
    TToolButton *ToolButton44;
    TAction *ViewDistributionAction;
    TAction *ViewParetoAction;
    TToolButton *ToolButtonSpacerPareto;
    TMenuItem *ViewDistributionChart1;
    TMenuItem *ViewParetoChart1;
    TTimer *ThreadMonitorTimer;
    TButton *CancelCollectionButton;
    TMenuItem *ViewChartTube12;
    TAction *ViewChartCurrent;
    TPageControl *PlotSelectorPageControl;
    TTabSheet *TemperatureTabSheet;
    TTabSheet *GasTabSheet;
    TTabSheet *LoadStationTabSheet;
    TTabSheet *EventsTabSheet;
    TChartListBox *GasChartListBox;
    TChartListBox *LoadStationChartListBox;
    TUpDown *TCUvAxisUpDown;
    TTabSheet *TCUvTabSheet;
    TChartListBox *ThermocoupleMicrovoltsChartListBox;
    TCheckListBox *EventsCheckListBox;
    TLineSeries *Series80;
    TTabSheet *StatsTabSheet;
    TPanel *Panel1;
    TComboBox *StatParameterComboBox;
    TChartListBox *StatsChartListBox;
    TLabel *StatParameterLabel;
    TPageControl *InvisiblePageControl;
    TTabSheet *EventCountsTabSheet;
    TGanttSeries *Series81;
    TClipSeriesTool *ChartClipSeriesTool;
    TChartListBox *EventsChartListBox;
    TChartListBox *EventCountsChartListBox;
    TMenuItem *LatestBatchatTop1;
    TAction *ViewLatestBatchAtTop;
	TTimer *LogDownTimer;
	TImageList *ToolBarGreyedImageList;
	TToolButton *ToolButton21;
	TToolButton *ToolButton25;
	TToolButton *ToolButton45;
	TAction *ViewNextBackgroundAction;
	TAction *ViewNextLineWidthAction;
	TMenuItem *UseNextBackgroundColour1;
	TMenuItem *UseNextLineWidth1;
	TToolButton *ToolButton46;
	TAction *ViewTCuVAction;
	TMenuItem *TCMicroVolts1;
	TAction *ToolsBackupScanAction;
	TMenuItem *ForceBackupScan1;
    TToolButton *ToolButton47;
    TMenuItem *StdDev1;
    TAction *ViewStdDevAction;
    TLabel *StackNameLabel;
    TComboBox *StackNameComboBox;
	TLabel *Label2;
	TLabel *Label3;
	TButton *Button1;
	void __fastcall Button1Click(TObject *Sender);

public:
    enum {  STARTSERIESPREDEF1 = 0,
            ENDSERIESPREDEF1 = 41,
            STARTSERIESPREDEF2 = 66,
            ENDSERIESPREDEF2 = 77};
private:	// User declarations

public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif

